<template>
  <v-main>
    <v-card :loading="loading" outlined>
      <v-card-title>
        {{ bug.title }}
      </v-card-title>
      <v-card-text>
        Пожалуйста, нажмите на кнопку ниже.
      </v-card-text>
      <v-card-actions>
        <v-btn :disabled="loading" :loading="loading" color="primary" @click="getToken()">Получить токен</v-btn>
        <v-btn :disabled="loading" :loading="loading" color="error" @click="goBack()">Отмена</v-btn>
      </v-card-actions>
    </v-card>
  </v-main>
</template>

<script lang="ts">
import Vue from 'vue';
import { Bug, BugsTypes } from '~/types';
import { serializeError } from 'serialize-error';

export default Vue.extend({
  name: 'ssr-token-get',
  scrollToTop: true,
  async asyncData({ app }) {
    if (!app.$accessor.bugsArray.find(x => x.type === BugsTypes.SSRTokenGet)) {
      await app.$accessor.loadBugs();
    }

    return {
      bug: app.$accessor.bugsArray.find(x => x.type === BugsTypes.SSRTokenGet),
    };
  },
  data() {
    return {
      bug: {} as Bug,
      loading: false,
    };
  },
  methods: {
    async getToken() {
      this.loading = true;
      try {
        this.bug.message = await this.$wnm.vkGetToken(false, '', this.$accessor.appId);
        delete this.bug.error;
      }
      catch (e) {
        this.bug.error = serializeError(e);
        delete this.bug.message;
      }
      await this.$nextTick();
      this.$router.replace('/');
    },
    async goBack() {
      this.loading = true;
      this.bug.error = 'Отменено пользователем';
      delete this.bug.message;
      await this.$nextTick();
      this.$router.replace('/');
    },
  },
});
</script>

<style scoped>

</style>
